import time

import read_data
import plot_panels
#import plot_panels0
import def_classes
import dsx_orbit
import plot_panels_InvsOut
import plot_panels_dots
import plot_Q
import plot_one_param
import plot_comparison
import plot_RaCa_by_fcefpe
import plot_panels_parallel
import plot_Ra_and_Ex_fig4
import plot_current_vs_freq
import read_data_cur
import plot_TATU_comparison

class plot_button():
    def __init__(self, rwd, opendir, band, binwd, ioflag, plottp, compa, V0f, \
        combin, corx, symm):
        self.rwd=rwd
        self.opendir=opendir
        self.band=band
        self.binwd=binwd
        self.ioflag=ioflag
        self.plottp=plottp
        self.compa=compa
        self.V0f=V0f
        self.combin=combin
        self.corx=corx
        self.fl=[]
        self.canv=None
        self.toolbar=0
        self.fig=None
        self.symm=symm

    def wplot(self):
        fpath=self.opendir.fpath
        if fpath == '':
            def_classes.print_message('Directory not selected')
            return -1

        bandname=self.band.get()
        if bandname == 'High-Band':
            L=0.0375
        elif bandname == 'Mid-Band':
            L=0.3015
        else:
            L=2.1515

        bwd=float(self.binwd.get())

        wd=self.rwd
        fig=self.fig
        canv=self.canv
        toolbar=self.toolbar
        plottp=self.plottp
        compa=self.compa
        V0=int(self.V0f.get())
        comb=self.combin.get()
        corx=self.corx.get()
        symm=self.symm.get()

        print('symm=',symm)

        ptype=plottp.get()
        if ptype=='Va_CaRaPa' or ptype=='fr+_vs_fr-' or ptype=='Va+_vs_Va-':
            ts=time.time()

            # --- read DSX orbit data and determine periods of inside plasmasphere
            # --- write the results in a file inside_pp.dat
            err = dsx_orbit.dsx_orbit(fpath)
            if err == -1:
                return -1

            # --- read file inside_pp.dat
            in_pp = read_data.input_inside_pp(fpath)
            if len(in_pp) == 0:
                def_classes.print_message('No data file for flag to ' \
                    +'inside/outside plasmasphere')
                return -1

            # --- read high power data
            data_all = read_data.input_data(fpath,L,bandname,in_pp,self.ioflag)

            if len(data_all) == 0:
                def_classes.print_message('No High Power Data: No data files ' \
                    +'or band not match')
                return -1

            te=time.time()
            th=(te-ts)/60.0
            print("Time used to process transimission data: ",th," min")

        if ptype == 'Va_CaRaPa':
            # --- plot Va - frequency curves as function of LC1 and LCt
            # --- plot Ca, Ra, Prad
            if comb == 'Yes':
                self.canv, self.fig, self.toolbar = \
                plot_panels.plot_VaRaCaPrad_comb(wd, canv, fig, toolbar, fpath, \
                    data_all, bwd, bandname, self.ioflag.get(), symm)
            else:
                self.canv, self.fig, self.toolbar = \
                plot_panels.plot_VaRaCaPrad(wd, canv, fig, toolbar, fpath, data_all, \
                    bwd, bandname, self.ioflag.get(), symm)

        elif ptype=='fr+_vs_fr-':
            self.canv, self.fig, self.toolbar = \
                plot_TATU_comparison.plot_frp_frm(wd, canv, fig, toolbar,data_all, bandname)

        elif ptype=='Va+_vs_Va-':
            self.canv, self.fig, self.toolbar = \
                plot_TATU_comparison.plot_Vap_Vam(wd, canv, fig, toolbar,data_all, bandname)

        elif ptype=='Ia+_vs_Ia-':
#---- read meadured current from High power current data file
            data_all=read_data_cur.input_data_cur(fpath)

            if len(data_all) == 0:
                def_classes.print_message('No High Power Current Data: No data files')
                return -1

            self.canv, self.fig, self.toolbar = \
                plot_TATU_comparison.plot_Iap_Iam(wd, canv, fig, toolbar,data_all, bandname)

        elif ptype == 'CaRaPa':
            # --- plot Ca, Ra, Prad only
            if compa.get() == 'Yes':
                #compare In and Out plasmasphere measurements for Y+
                self.canv, self.fig, self.toolbar, self.fl = \
                    plot_panels_InvsOut.plot_comp_In_Out(wd, canv, fig, toolbar, \
                        fpath, bwd, L, bandname, self.ioflag.get(), self.fl, V0, comb)
            else:
                #Combine Y+ and Y- TATUs
                self.canv, self.fig, self.toolbar = \
                    plot_panels.plot_Ra_Ca_Prad(wd, canv, fig, toolbar, fpath, bwd, \
                        L, bandname, self.ioflag.get(), V0, comb, corx)
        elif ptype =='CaRa_comp':
            self.canv, self.fig, self.toolbar = \
                plot_comparison.plot_RaCa_comparison(wd, canv, fig, toolbar, fpath, \
                    bwd, L, bandname, self.ioflag.get(), V0, corx)
        elif ptype =='CaRa_fcefpe':
            self.canv, self.fig, self.toolbar = \
                plot_RaCa_by_fcefpe.plot_RaCa_byfcefpe(wd, canv, fig, toolbar, fpath, \
                    bwd, L, bandname, self.ioflag.get(), V0, corx)
        elif ptype == 'CaRaPa_d':
            # --- plot Ca, Ra, Prad only
            #if compa.get() == 'Yes':
                #compare In and Out plasmasphere measurements for Y+
            #    self.canv, self.fig, self.toolbar = \
            #        plot_panels_InvsOut.plot_comp_In_Out(wd, canv, fig, toolbar, \
            #            fpath, bwd, L, bandname, self.ioflag.get())
            #else:
                #Compare Y+ and Y- TATUs
                self.canv, self.fig, self.toolbar, self.fl = \
                    plot_panels_dots.plot_Ra_Ca_Prad_dots(wd, canv, fig, toolbar, fpath, \
                        bwd, L, bandname, self.ioflag.get(), self.fl)
        elif ptype == 'Ca_Only' or ptype == 'Ra_Only' or ptype == 'Pa_Only' \
            or ptype == 'Eff_Only':
            # --- plot one of Ca, Ra or Pa, or Radiation efficiency ----
            if compa.get() == 'Yes':
                self.canv, self.fig, self.toolbar, self.fl = \
                plot_one_param.plot_one_InvsOut(wd, canv, fig, toolbar, fpath, bwd, L, \
                bandname, self.ioflag.get(), ptype, V0, self.fl, comb)
            else:
                self.canv, self.fig, self.toolbar, self.fl = \
                plot_one_param.plot_one_InOut(wd, canv, fig, toolbar, fpath, bwd, L, \
                bandname, self.ioflag.get(), ptype, V0, self.fl)
        elif ptype == 'p_CaRaPa':
            self.canv, self.fig, self.toolbar = \
                plot_panels_parallel.plot_p_RaCaPrad(wd, canv, fig, toolbar, fpath, \
                    bwd, L, bandname, self.ioflag.get(), V0, comb, corx)
        elif ptype == 'Q':
            # --- plot Q ----
            if compa.get() == 'Yes':
                self.canv, self.fig, self.toolbar, self.fl = \
                    plot_Q.plot_Q_In_Out(wd, canv, fig, toolbar, fpath, bwd, L, \
                        bandname, self.ioflag.get(), self.fl)
            else:
                self.canv, self.fig, self.toolbar, self.fl = \
                    plot_Q.plot_Q_all(wd, canv, fig, toolbar, fpath, bwd, L, \
                        bandname, self.ioflag.get(), self.fl)
        elif ptype == 'Ra&Ex':
            self.canv, self.fig, self.toolbar = \
                plot_Ra_and_Ex_fig4.plot_RaEx_fig4(wd, canv, fig, toolbar, fpath, bwd, \
                        L, bandname, self.ioflag.get(), V0, comb)
        elif ptype == 'Current':
            self.canv, self.fig, self.toolbar = \
                plot_current_vs_freq.plot_Ia_freq(wd, canv, fig, toolbar, fpath, bwd, \
                        L, bandname, self.ioflag.get(), V0, comb)

        #elif ptype =='ieee_paper':
        #    self.canv, self.fig, self.toolbar = \
        #        ieee_paper_fig.ieee_paper_fig(wd, canv, fig, toolbar, fpath)

        return 0
