# -*- coding: utf-8 -*-
"""
Created on Wed Sep 18 09:52:03 2019

@author: jtu
"""
import os
#import numpy as np
import sys

# input high power measuremets current data
def input_data_cur(fpath):
    datet=''
    t=0.0
    Qp=0.0
    Qm=0.0
    progn=0

    fname=[]

    data_cur=[]

    print('Read high power transmission current data ...')

    for rootp, dirn, fn in os.walk(fpath):
        for files in fn:
            if 'Current' in files:
                fname.append(os.path.join(rootp,files))

    fname.sort()

    nf=len(fname)

    # check if there are any high power data files exist
    if nf == 0:
        print('No high data files in specified directory its subdirectories')
        sys.exit()

    fname.sort()

    for i in range(0,nf):
        sentv =[]
        sentv3=[]
        fq=[]
        cur1=[]
        phi1=[]
        cur2=[]
        phi2=[]
        cur31=[]
        phi31=[]
        cur32=[]
        phi32=[]

        print(fname[i][len(fname[i])-62:len(fname[i])])
        with open(fname[i], 'r') as fid:
            for j in range(0,9):     #remove headers
                fid.readline()

            #read all the other lines from the file
            fl=fid.readlines()
            fid.close()

        if len(fl) < 37:
            print('No measurement records in the file:')
            print(os.path.basename(fname[i])+'. Open and read next file, if any')
            continue

        #loop lines to assing data to lists
        for j in range(len(fl)):
            if '#====' in fl[j]: #measurment starting delimiter
                k=j
                if j > 0:
                    #store processed data in the lists of lists
                    data_sub=[datet,t,sentv,sentv3,[Qp,Qm],fq,cur1,cur31,phi1, \
                        phi31,cur2,cur32,phi2,phi32,progn]

                    data_cur.append(data_sub)

                    #rest lists as empty
                    sentv =[]
                    sentv3=[]
                    fq=[]
                    cur1=[]
                    phi1=[]
                    cur2=[]
                    phi2=[]
                    cur31=[]
                    phi31=[]
                    cur32=[]
                    phi32=[]

            # end if and start else
            else: #process measurement data and record then store in lists
                a=fl[j].split()

                if j == k+1:
                    datet=a[2]+' '+a[3]
                    t=float(a[3][0:2])*60+float(a[3][3:5])+float(a[3][6:8])/60.0
                elif j == k+2:
                    progn=int(a[2][1:3])
                elif (j >= k+5 and j <= k+7) or (j >= k+10 and j <= k+12):
                    sentv.append(float(a[5]))
                    sentv3.append(float(a[7]))
                elif j == k+15:
                    Qp=float(a[5])
                elif j == k+20:
                    Qm=float(a[5])
                elif j > k+25:
                    fq.append(float(a[0]))
                    cur1.append(float(a[2]))
                    cur31.append(float(a[4]))
                    ind=a[5].find('00-')
                    if ind !=-1:
                        a[5]=a[5][0:ind+2]+'0'+a[5][ind+3:len(a[5])]
                    phi1.append(float(a[5]))
                    ind=a[6].find('00-')
                    if ind !=-1:
                        a[6]=a[6][0:ind+2]+'0'+a[6][ind+3:len(a[6])]
                    phi31.append(float(a[6]))
                    cur2.append(float(a[8]))
                    cur32.append(float(a[10]))
                    phi2.append(float(a[11]))
                    phi32.append(float(a[12]))

             # end else
        # end for loop of number of lines in a file

        #after reading last measurement record in the file
        #store processed data in the lists of lists
        data_sub=[datet,t,sentv,sentv3,[Qp,Qm],fq,cur1,cur31,phi1,phi31 ,\
                cur2,cur32,phi2,phi32,progn]

        data_cur.append(data_sub)
 
    #end for loop of number of files

    print('Finished reading high power transmission data')

    return data_cur